/* Nécessite JQuery */

/* Structure html/css/js de Nicolas Buyle-Bodin sous licence Creative Commons BY-NC-SA */
/* Respect de la Paternité - Pas d'utilisation commerciale - Partage des conditions initiales à l'identique */

 

$(function() {

		/* ********************************************************
						Donnees pour le Menu
		******************************************************** */
		var noms_menu =	[
							'Accueils',
							'Les Listes',
							'Courbes Représentatives',
							'Les suites',
							'Fichiers et sélection de données',
							'La Tortue',
							'Calcul formel',
							'Compléments sur les Fonctions',							 
							'Types avancés',
							'Créer un module de fonctions'
													
						];

		// Lien  relatif des pages. Si la page est dans le même dossier, son chemin relatif
		// doit être construit en le précédent de "./".¨Par exemple : "./accueil.html"
		// Normalement, cela ne doit pas s'appliquer pour le site de formation
		var liste_onglets =	[	[
									['Index Général', '../../index_general.html'],
									['Plan de la formation', '../accueil_python_1ere.html']
								],
								
								[ 	/* Listes */
									['Définition', '../listes/def_liste.html'],
									['Opérations sur les listes', '../listes/operations_liste.html'],
									['Les listes - Exercices', '../listes/liste_exos.html'],
									['Générer une liste', '../listes/generer_liste.html'],
									['Générer une liste - Exercices', '../listes/generer_liste_exos.html'],
									['Algorithmes de référence', '../listes/algo_liste_exos.html'],
									['Statistiques', '../listes/liste_stat.html'],
									['Arithmétique', '../listes/liste_arithm.html'],
									['Exercices supplémentaires', '../listes/liste_exos_sup.html'],
								],
								 
								[ 	/* courbes */
									['Matplotlib', '../courbe/matplotlib.html'],
									['Représentation graphique', '../courbe/pylab1.html'],
									['Canonique', '../courbe/canon.html'],
								],
								 
								[ 	/* suites */
									['Termes d\'une suite', '../suites/suites_termes.html'],
									['Algorithmes et suites', '../suites/suites_algo.html'],
									['Suite de Syracuse', '../suites/suites_syracuse.html'],
								],
								
								[ 	/* données réelles */
									['Format CSV', '../fichier/csv.html'],
									['De python vers CSV', '../fichier/versCsv.html'],
									['Fichier texte', '../fichier/texte.html'],
								],
								
								[ 	/* tortue */
									['Dessiner avec turtle', '../tortue/description_turtle.html'],
									['Exercices', '../tortue/tortue1.html'],
									['Encore des exercices', '../tortue/tortue2.html']
								],
																
								[ 	/* formel */
									['Sympy', '../formel/sympy.html'],
								],
								
								[ 	/* fonctions */
									['Portée d\'une variable', '../fonction/scope.html'],
									['Retourner une fonction', '../fonction/fonctionInFonction.html'],
									['Fonction en paramètre', '../fonction/fonction_param.html'],
									['Des paramètres, encore', '../fonction/paramparam.html'],
									['Exercice en seconde', '../fonction/algebre.html'],
									
								],
								
								[ 	/* structures */
									['Distance', '../structure/structure1.html'],
									['Colinéarité, fractions', '../structure/structure2.html'],
								],	
								
								[ 	/* modules */
									['Introduction', '../module/module1.html'],
									['Créer un module', '../module/module2.html'],
									['Des rationnels', '../module/module3.html'],
								],
								 
							];


		/* ********************************************************
						Tableaux des En-têtes
		******************************************************** */		
		
		var menugauche = document.getElementById('menu_accordeon');
		var taille = Math.min(noms_menu.length, liste_onglets.length);


		/* ********************************************************
						Nommer les En-Têtes
		******************************************************** */		
		var tab_label = [];
		var tab_span_label = [];
		var tab_items = []
		for(i=0; i < taille; i++) {
			// pour créer les listes d'en-têtes et les nommer :
			tab_label[i] = document.createElement('li');
			tab_label[i].className = 'deroulant';
			menugauche.appendChild(tab_label[i]);
			
			tab_span_label[i] = document.createElement('span');
			tab_span_label[i].innerHTML = noms_menu[i];
			tab_label[i].appendChild(tab_span_label[i]);
			
			tab_items[i] = document.createElement('ul');
			tab_items[i].className = 'items';
			tab_label[i].appendChild(tab_items[i]);
						
			};


		/* ********************************************************
			Retrouver et extraire le nom de la page actuelle
		******************************************************** */	
		var name = window.location.pathname
		var fin = name.substring(name.lastIndexOf("/"));
		
		// Recherche des "coordonnées" du lien concernant la page actuelle
		var x = -1;
		var y = -1;
		for(i=0; i < liste_onglets.length; i++) {
			for(j=0; j < liste_onglets[i].length; j++) {
				if (fin == liste_onglets[i][j][1].substring(liste_onglets[i][j][1].lastIndexOf("/")) ) {
					x = i;
					y = j;
					};
				};
			};
		
		// Modification des liens dans le cas où l'utilisateur est dans la page d'accueil de la capsule
		if ((x==0) && (y==1)) {
			for(i=0; i < liste_onglets.length; i++) {
				for(j=0; j < liste_onglets[i].length; j++) {
					liste_onglets[i][j][1] = liste_onglets[i][j][1].substring(3)
					};
				};
			};


		/* ********************************************************
						Navigation dans le site
		******************************************************** */	
		var tab_li = [];
		var tab_liens = [];
		for(i=0; i < taille; i++) {
			for(j=0; j < liste_onglets[i].length; j++) {
				// Association des noms de page avec leur URL
				tab_li[j] = document.createElement('li');
				tab_liens[j] = document.createElement('a');
				tab_liens[j].href = liste_onglets[i][j][1];
				tab_items[i].appendChild(tab_li[j]);
				tab_li[j].appendChild(tab_liens[j]);
				tab_liens[j].appendChild(document.createTextNode(liste_onglets[i][j][0]));
			};
		};


		/* ********************************************************
			Passage d'une page à la précédente ou à la suivante
		******************************************************** */	
		var menu_droit = document.getElementById('menu_droit');
		var liens = menu_droit.getElementsByTagName('a');
		// Page précédente
		if (((x==0) && (y==1)) || ((x==1) && (y==0))) {
			liens[1].href = liste_onglets[0][1][1];
			}
		else if (y==0) {
			liens[1].href = liste_onglets[x-1][liste_onglets[x-1].length-1][1];
			}
		else {
			liens[1].href = liste_onglets[x][y-1][1];
			}
		// Page suivante
		if ((x==0) && (y==0)) {
			liens[2].href = liste_onglets[1][0][1];
			}
		else if ((x==liste_onglets.length-1) && (y==liste_onglets[x].length-1)) {
			liens[2].href = liste_onglets[0][1][1];
			}
		else if (y==liste_onglets[x].length-1) {
			liens[2].href = liste_onglets[x+1][0][1];
			}
		else {
			liens[2].href = liste_onglets[x][y+1][1];
			}
		// Index général du site
		liens[3].href = liste_onglets[0][0][1];
		


		/* ********************************************************
			Fil d'ariane - Au maximum un dossier dans la capsule
		******************************************************** */
		var ariane = document.getElementById('ariane');
		var ariane_li = [];
		var ariane_liens = [];
		
		// Index Général et Nom de la formation
		for(i=0; i < 2; i++) {
			ariane_li[i] = document.createElement('li');
			ariane_liens[i] = document.createElement('a');
			ariane_liens[i].href = liste_onglets[0][i][1];
			ariane.appendChild(ariane_li[i]);
			ariane_li[i].appendChild(ariane_liens[i]);
			ariane_liens[i].appendChild(document.createTextNode(liste_onglets[0][i][0]));
			};
		
		// Dossier et page correspondante
		if (x>0) {
			ariane_li[2] = document.createElement('li');
			ariane_li[2].innerHTML = noms_menu[x];
			ariane.appendChild(ariane_li[2]);
			
			ariane_li[3] = document.createElement('li');
			ariane_liens[3] = document.createElement('a');
			ariane_liens[3].href = liste_onglets[x][y][1];
			ariane.appendChild(ariane_li[3]);
			ariane_li[3].appendChild(ariane_liens[3]);
			ariane_liens[3].appendChild(document.createTextNode(liste_onglets[x][y][0]));
			};
		


		/* ********************************************************
			Affichage du plan dans la page d'accueil de la capsule
		******************************************************** */
		if ((x==0) && (y==1)) {
			var plan = document.getElementById('plan');
			var plan_label = [];
			var plan_item = [];
			var plan_lien = [];
			
			for(i=1; i < taille; i++) {
				// pour créer les listes d'en-têtes et les nommer :
				plan_label[i-1] = document.createElement('ul');
				plan_label[i-1].className = 'plan_label';
				plan.appendChild(plan_label[i-1]);
				
				plan_item[0] = document.createElement('li');
				plan_label[i-1].appendChild(plan_item[0]);
				plan_item[0].innerHTML = noms_menu[i];
				
				for(j=1; j <= liste_onglets[i].length; j++) {
					plan_item[j] = document.createElement('li');
					plan_lien[j] = document.createElement('a');
					plan_lien[j].href = liste_onglets[i][j-1][1];
					plan_label[i-1].appendChild(plan_item[j]);
					plan_item[j].appendChild(plan_lien[j]);
					plan_lien[j].appendChild(document.createTextNode(liste_onglets[i][j-1][0]));
					};
				};
			};
		

}); // fin de création des menus


$(document).ready( function () {
	// Source : https://www.alsacreations.com/tuto/lire/604-Creer-un-menu-accordeon-avec-jQuery.html
	// On cache les sous-menus :
	$(".deroulant ul.items").hide();
	
	// Substitution dynamique des titres de menu <span> par des liens
	$(".deroulant span").each( function () {
		var texte_span = $(this).text();
        $(this).replaceWith('<a href="" title="Afficher les items">' + texte_span + '<\/a>') ;
    } ) ;
	
    // Réception des événements
	$(".deroulant > a").click( function () {
        // Si le sous-menu était déjà ouvert, on le referme :
        if ($(this).next("ul.items:visible").length != 0) {
            $(this).next("ul.items").slideUp("normal", function () { $(this).parent().removeClass("menu_ouvert") });
        }
        // Si le sous-menu est caché, on ferme les autres et on l'affiche :
        else {
            $(".deroulant ul.items").slideUp("normal", function () { $(this).parent().removeClass("menu_ouvert") });
            $(this).next("ul.items").slideDown("normal", function () { $(this).parent().addClass("menu_ouvert") });
        }
        // On empêche le navigateur de suivre le lien :
        return false;
    });   
  
} ) ;


